diff -Naur openssh-3.4p1/config.h.in openssh-3.4p1-gsi/config.h.in
--- openssh-3.4p1/config.h.in	Wed Jun 26 09:08:19 2002
+++ openssh-3.4p1-gsi/config.h.in	Tue Jul  2 08:30:04 2002
@@ -1,4 +1,4 @@
-/* config.h.in.  Generated from configure.ac by autoheader.  */
+/* config.h.in.  Generated automatically from configure.ac by autoheader.  */
 /* $Id: acconfig.h,v 1.141 2002/06/25 22:35:16 tim Exp $ */
 
 #ifndef _CONFIG_H
@@ -8,6 +8,7 @@
 /* Please make your changes there */
 
 
+
 /* Define to a Set Process Title type if your system is */
 /* supported by bsd-setproctitle.c */
 #undef SPT_TYPE
@@ -198,6 +199,9 @@
 /* Define if compiler implements __func__ */
 #undef HAVE___func__
 
+/* Define this is you want GSSAPI support in the version 2 protocol */
+#undef GSSAPI
+
 /* Define if you want Kerberos 5 support */
 #undef KRB5
 
@@ -210,6 +214,9 @@
 /* Define if you want AFS support */
 #undef AFS
 
+/* Define if you want GSI/Globus authentication support */
+#undef GSI
+
 /* Define if you want S/Key support */
 #undef SKEY
 
@@ -362,489 +369,480 @@
 #undef BROKEN_FD_PASSING
 
 
-/* Define to 1 if the `getpgrp' function requires zero arguments. */
+/* Define if the `getpgrp' function takes no argument. */
 #undef GETPGRP_VOID
 
-/* Define to 1 if you have the `arc4random' function. */
+/* Define if you have the `arc4random' function. */
 #undef HAVE_ARC4RANDOM
 
-/* Define to 1 if you have the `b64_ntop' function. */
+/* Define if you have the `b64_ntop' function. */
 #undef HAVE_B64_NTOP
 
-/* Define to 1 if you have the `bcopy' function. */
+/* Define if you have the `bcopy' function. */
 #undef HAVE_BCOPY
 
-/* Define to 1 if you have the `bindresvport_sa' function. */
+/* Define if you have the `bindresvport_sa' function. */
 #undef HAVE_BINDRESVPORT_SA
 
-/* Define to 1 if you have the <bstring.h> header file. */
+/* Define if you have the <bstring.h> header file. */
 #undef HAVE_BSTRING_H
 
-/* Define to 1 if you have the `clock' function. */
+/* Define if you have the `clock' function. */
 #undef HAVE_CLOCK
 
-/* Define to 1 if you have the <crypt.h> header file. */
+/* Define if you have the <crypt.h> header file. */
 #undef HAVE_CRYPT_H
 
-/* Define to 1 if you have the `dirname' function. */
+/* Define if you have the `dirname' function. */
 #undef HAVE_DIRNAME
 
-/* Define to 1 if you have the <endian.h> header file. */
+/* Define if you have the <endian.h> header file. */
 #undef HAVE_ENDIAN_H
 
-/* Define to 1 if you have the `endutent' function. */
+/* Define if you have the `endutent' function. */
 #undef HAVE_ENDUTENT
 
-/* Define to 1 if you have the `endutxent' function. */
+/* Define if you have the `endutxent' function. */
 #undef HAVE_ENDUTXENT
 
-/* Define to 1 if you have the `fchmod' function. */
+/* Define if you have the `fchmod' function. */
 #undef HAVE_FCHMOD
 
-/* Define to 1 if you have the `fchown' function. */
+/* Define if you have the `fchown' function. */
 #undef HAVE_FCHOWN
 
-/* Define to 1 if you have the <floatingpoint.h> header file. */
+/* Define if you have the <floatingpoint.h> header file. */
 #undef HAVE_FLOATINGPOINT_H
 
-/* Define to 1 if you have the `freeaddrinfo' function. */
+/* Define if you have the `freeaddrinfo' function. */
 #undef HAVE_FREEADDRINFO
 
-/* Define to 1 if you have the `futimes' function. */
+/* Define if you have the `futimes' function. */
 #undef HAVE_FUTIMES
 
-/* Define to 1 if you have the `gai_strerror' function. */
+/* Define if you have the `gai_strerror' function. */
 #undef HAVE_GAI_STRERROR
 
-/* Define to 1 if you have the `getaddrinfo' function. */
+/* Define if you have the `getaddrinfo' function. */
 #undef HAVE_GETADDRINFO
 
-/* Define to 1 if you have the `getcwd' function. */
+/* Define if you have the `getcwd' function. */
 #undef HAVE_GETCWD
 
-/* Define to 1 if you have the `getgrouplist' function. */
+/* Define if you have the `getgrouplist' function. */
 #undef HAVE_GETGROUPLIST
 
-/* Define to 1 if you have the `getluid' function. */
+/* Define if you have the `getluid' function. */
 #undef HAVE_GETLUID
 
-/* Define to 1 if you have the `getnameinfo' function. */
+/* Define if you have the `getnameinfo' function. */
 #undef HAVE_GETNAMEINFO
 
-/* Define to 1 if you have the `getopt' function. */
+/* Define if you have the `getopt' function. */
 #undef HAVE_GETOPT
 
-/* Define to 1 if you have the <getopt.h> header file. */
+/* Define if you have the <getopt.h> header file. */
 #undef HAVE_GETOPT_H
 
-/* Define to 1 if you have the `getpwanam' function. */
+/* Define if you have the `getpwanam' function. */
 #undef HAVE_GETPWANAM
 
-/* Define to 1 if you have the `getrlimit' function. */
+/* Define if you have the `getrlimit' function. */
 #undef HAVE_GETRLIMIT
 
-/* Define to 1 if you have the `getrusage' function. */
+/* Define if you have the `getrusage' function. */
 #undef HAVE_GETRUSAGE
 
-/* Define to 1 if you have the `gettimeofday' function. */
+/* Define if you have the `gettimeofday' function. */
 #undef HAVE_GETTIMEOFDAY
 
-/* Define to 1 if you have the `getttyent' function. */
+/* Define if you have the `getttyent' function. */
 #undef HAVE_GETTTYENT
 
-/* Define to 1 if you have the `getutent' function. */
+/* Define if you have the `getutent' function. */
 #undef HAVE_GETUTENT
 
-/* Define to 1 if you have the `getutid' function. */
+/* Define if you have the `getutid' function. */
 #undef HAVE_GETUTID
 
-/* Define to 1 if you have the `getutline' function. */
+/* Define if you have the `getutline' function. */
 #undef HAVE_GETUTLINE
 
-/* Define to 1 if you have the `getutxent' function. */
+/* Define if you have the `getutxent' function. */
 #undef HAVE_GETUTXENT
 
-/* Define to 1 if you have the `getutxid' function. */
+/* Define if you have the `getutxid' function. */
 #undef HAVE_GETUTXID
 
-/* Define to 1 if you have the `getutxline' function. */
+/* Define if you have the `getutxline' function. */
 #undef HAVE_GETUTXLINE
 
-/* Define to 1 if you have the `glob' function. */
+/* Define if you have the `glob' function. */
 #undef HAVE_GLOB
 
-/* Define to 1 if you have the <glob.h> header file. */
+/* Define if you have the <glob.h> header file. */
 #undef HAVE_GLOB_H
 
-/* Define to 1 if you have the `inet_aton' function. */
+/* Define if you have the <gssapi.h> header file. */
+#undef HAVE_GSSAPI_H
+
+/* Define if you have the `inet_aton' function. */
 #undef HAVE_INET_ATON
 
-/* Define to 1 if you have the `inet_ntoa' function. */
+/* Define if you have the `inet_ntoa' function. */
 #undef HAVE_INET_NTOA
 
-/* Define to 1 if you have the `inet_ntop' function. */
+/* Define if you have the `inet_ntop' function. */
 #undef HAVE_INET_NTOP
 
-/* Define to 1 if you have the `innetgr' function. */
+/* Define if you have the `innetgr' function. */
 #undef HAVE_INNETGR
 
-/* Define to 1 if you have the <inttypes.h> header file. */
+/* Define if you have the <inttypes.h> header file. */
 #undef HAVE_INTTYPES_H
 
-/* Define to 1 if you have the <krb.h> header file. */
+/* Define if you have the <krb.h> header file. */
 #undef HAVE_KRB_H
 
-/* Define to 1 if you have the <lastlog.h> header file. */
+/* Define if you have the <lastlog.h> header file. */
 #undef HAVE_LASTLOG_H
 
-/* Define to 1 if you have the `des' library (-ldes). */
+/* Define if you have the `des' library (-ldes). */
 #undef HAVE_LIBDES
 
-/* Define to 1 if you have the `des425' library (-ldes425). */
+/* Define if you have the `des425' library (-ldes425). */
 #undef HAVE_LIBDES425
 
-/* Define to 1 if you have the `dl' library (-ldl). */
+/* Define if you have the `dl' library (-ldl). */
 #undef HAVE_LIBDL
 
-/* Define to 1 if you have the <libgen.h> header file. */
+/* Define if you have the <libgen.h> header file. */
 #undef HAVE_LIBGEN_H
 
-/* Define to 1 if you have the `krb' library (-lkrb). */
+/* Define if you have the `krb' library (-lkrb). */
 #undef HAVE_LIBKRB
 
-/* Define to 1 if you have the `krb4' library (-lkrb4). */
+/* Define if you have the `krb4' library (-lkrb4). */
 #undef HAVE_LIBKRB4
 
-/* Define to 1 if you have the `nsl' library (-lnsl). */
+/* Define if you have the `nsl' library (-lnsl). */
 #undef HAVE_LIBNSL
 
-/* Define to 1 if you have the `pam' library (-lpam). */
+/* Define if you have the `pam' library (-lpam). */
 #undef HAVE_LIBPAM
 
-/* Define to 1 if you have the `resolv' library (-lresolv). */
+/* Define if you have the `resolv' library (-lresolv). */
 #undef HAVE_LIBRESOLV
 
-/* Define to 1 if you have the `sectok' library (-lsectok). */
+/* Define if you have the `sectok' library (-lsectok). */
 #undef HAVE_LIBSECTOK
 
-/* Define to 1 if you have the `socket' library (-lsocket). */
+/* Define if you have the `socket' library (-lsocket). */
 #undef HAVE_LIBSOCKET
 
-/* Define to 1 if you have the <libutil.h> header file. */
+/* Define if you have the <libutil.h> header file. */
 #undef HAVE_LIBUTIL_H
 
-/* Define to 1 if you have the `z' library (-lz). */
+/* Define if you have the `z' library (-lz). */
 #undef HAVE_LIBZ
 
-/* Define to 1 if you have the <limits.h> header file. */
+/* Define if you have the <limits.h> header file. */
 #undef HAVE_LIMITS_H
 
-/* Define to 1 if you have the <login_cap.h> header file. */
+/* Define if you have the <login_cap.h> header file. */
 #undef HAVE_LOGIN_CAP_H
 
-/* Define to 1 if you have the `login_getcapbool' function. */
+/* Define if you have the `login_getcapbool' function. */
 #undef HAVE_LOGIN_GETCAPBOOL
 
-/* Define to 1 if you have the <login.h> header file. */
+/* Define if you have the <login.h> header file. */
 #undef HAVE_LOGIN_H
 
-/* Define to 1 if you have the `logout' function. */
+/* Define if you have the `logout' function. */
 #undef HAVE_LOGOUT
 
-/* Define to 1 if you have the `logwtmp' function. */
+/* Define if you have the `logwtmp' function. */
 #undef HAVE_LOGWTMP
 
-/* Define to 1 if you have the <maillock.h> header file. */
+/* Define if you have the <maillock.h> header file. */
 #undef HAVE_MAILLOCK_H
 
-/* Define to 1 if you have the `md5_crypt' function. */
+/* Define if you have the `md5_crypt' function. */
 #undef HAVE_MD5_CRYPT
 
-/* Define to 1 if you have the `memmove' function. */
+/* Define if you have the `memmove' function. */
 #undef HAVE_MEMMOVE
 
-/* Define to 1 if you have the <memory.h> header file. */
+/* Define if you have the <memory.h> header file. */
 #undef HAVE_MEMORY_H
 
-/* Define to 1 if you have the `mkdtemp' function. */
+/* Define if you have the `mkdtemp' function. */
 #undef HAVE_MKDTEMP
 
-/* Define to 1 if you have the `mmap' function. */
+/* Define if you have the `mmap' function. */
 #undef HAVE_MMAP
 
-/* Define to 1 if you have the <netdb.h> header file. */
+/* Define if you have the <netdb.h> header file. */
 #undef HAVE_NETDB_H
 
-/* Define to 1 if you have the <netgroup.h> header file. */
+/* Define if you have the <netgroup.h> header file. */
 #undef HAVE_NETGROUP_H
 
-/* Define to 1 if you have the <netinet/in_systm.h> header file. */
+/* Define if you have the <netinet/in_systm.h> header file. */
 #undef HAVE_NETINET_IN_SYSTM_H
 
-/* Define to 1 if you have the `ngetaddrinfo' function. */
+/* Define if you have the `ngetaddrinfo' function. */
 #undef HAVE_NGETADDRINFO
 
-/* Define to 1 if you have the `ogetaddrinfo' function. */
+/* Define if you have the `ogetaddrinfo' function. */
 #undef HAVE_OGETADDRINFO
 
-/* Define to 1 if you have the `openpty' function. */
+/* Define if you have the `openpty' function. */
 #undef HAVE_OPENPTY
 
-/* Define to 1 if you have the `pam_getenvlist' function. */
+/* Define if you have the `pam_getenvlist' function. */
 #undef HAVE_PAM_GETENVLIST
 
-/* Define to 1 if you have the <paths.h> header file. */
+/* Define if you have the `pam_putenv' function. */
+#undef HAVE_PAM_PUTENV
+
+/* Define if you have the <paths.h> header file. */
 #undef HAVE_PATHS_H
 
-/* Define to 1 if you have the <pty.h> header file. */
+/* Define if you have the <pty.h> header file. */
 #undef HAVE_PTY_H
 
-/* Define to 1 if you have the `pututline' function. */
+/* Define if you have the `pututline' function. */
 #undef HAVE_PUTUTLINE
 
-/* Define to 1 if you have the `pututxline' function. */
+/* Define if you have the `pututxline' function. */
 #undef HAVE_PUTUTXLINE
 
-/* Define to 1 if you have the `readpassphrase' function. */
+/* Define if you have the `readpassphrase' function. */
 #undef HAVE_READPASSPHRASE
 
-/* Define to 1 if you have the <readpassphrase.h> header file. */
+/* Define if you have the <readpassphrase.h> header file. */
 #undef HAVE_READPASSPHRASE_H
 
-/* Define to 1 if you have the `realpath' function. */
+/* Define if you have the `realpath' function. */
 #undef HAVE_REALPATH
 
-/* Define to 1 if you have the `recvmsg' function. */
+/* Define if you have the `recvmsg' function. */
 #undef HAVE_RECVMSG
 
-/* Define to 1 if you have the <rpc/types.h> header file. */
+/* Define if you have the <rpc/types.h> header file. */
 #undef HAVE_RPC_TYPES_H
 
-/* Define to 1 if you have the `rresvport_af' function. */
+/* Define if you have the `rresvport_af' function. */
 #undef HAVE_RRESVPORT_AF
 
-/* Define to 1 if you have the <sectok.h> header file. */
+/* Define if you have the <sectok.h> header file. */
 #undef HAVE_SECTOK_H
 
-/* Define to 1 if you have the <security/pam_appl.h> header file. */
+/* Define if you have the <security/pam_appl.h> header file. */
 #undef HAVE_SECURITY_PAM_APPL_H
 
-/* Define to 1 if you have the `sendmsg' function. */
+/* Define if you have the `sendmsg' function. */
 #undef HAVE_SENDMSG
 
-/* Define to 1 if you have the `setdtablesize' function. */
+/* Define if you have the `setdtablesize' function. */
 #undef HAVE_SETDTABLESIZE
 
-/* Define to 1 if you have the `setegid' function. */
+/* Define if you have the `setegid' function. */
 #undef HAVE_SETEGID
 
-/* Define to 1 if you have the `setenv' function. */
+/* Define if you have the `setenv' function. */
 #undef HAVE_SETENV
 
-/* Define to 1 if you have the `seteuid' function. */
+/* Define if you have the `seteuid' function. */
 #undef HAVE_SETEUID
 
-/* Define to 1 if you have the `setgroups' function. */
+/* Define if you have the `setgroups' function. */
 #undef HAVE_SETGROUPS
 
-/* Define to 1 if you have the `setlogin' function. */
+/* Define if you have the `setlogin' function. */
 #undef HAVE_SETLOGIN
 
-/* Define to 1 if you have the `setluid' function. */
+/* Define if you have the `setluid' function. */
 #undef HAVE_SETLUID
 
-/* Define to 1 if you have the `setpcred' function. */
+/* Define if you have the `setpcred' function. */
 #undef HAVE_SETPCRED
 
-/* Define to 1 if you have the `setproctitle' function. */
+/* Define if you have the `setproctitle' function. */
 #undef HAVE_SETPROCTITLE
 
-/* Define to 1 if you have the `setresgid' function. */
+/* Define if you have the `setresgid' function. */
 #undef HAVE_SETRESGID
 
-/* Define to 1 if you have the `setreuid' function. */
+/* Define if you have the `setreuid' function. */
 #undef HAVE_SETREUID
 
-/* Define to 1 if you have the `setrlimit' function. */
+/* Define if you have the `setrlimit' function. */
 #undef HAVE_SETRLIMIT
 
-/* Define to 1 if you have the `setsid' function. */
+/* Define if you have the `setsid' function. */
 #undef HAVE_SETSID
 
-/* Define to 1 if you have the `setutent' function. */
+/* Define if you have the `setutent' function. */
 #undef HAVE_SETUTENT
 
-/* Define to 1 if you have the `setutxent' function. */
+/* Define if you have the `setutxent' function. */
 #undef HAVE_SETUTXENT
 
-/* Define to 1 if you have the `setvbuf' function. */
+/* Define if you have the `setvbuf' function. */
 #undef HAVE_SETVBUF
 
-/* Define to 1 if you have the <shadow.h> header file. */
+/* Define if you have the <shadow.h> header file. */
 #undef HAVE_SHADOW_H
 
-/* Define to 1 if you have the `sigaction' function. */
+/* Define if you have the `sigaction' function. */
 #undef HAVE_SIGACTION
 
-/* Define to 1 if you have the `sigvec' function. */
+/* Define if you have the `sigvec' function. */
 #undef HAVE_SIGVEC
 
-/* Define to 1 if the system has the type `sig_atomic_t'. */
+/* Define if the system has the type `sig_atomic_t'. */
 #undef HAVE_SIG_ATOMIC_T
 
-/* Define to 1 if you have the `snprintf' function. */
+/* Define if you have the `snprintf' function. */
 #undef HAVE_SNPRINTF
 
-/* Define to 1 if you have the `socketpair' function. */
+/* Define if you have the `socketpair' function. */
 #undef HAVE_SOCKETPAIR
 
-/* Define to 1 if you have the <stddef.h> header file. */
+/* Define if you have the <stddef.h> header file. */
 #undef HAVE_STDDEF_H
 
-/* Define to 1 if you have the <stdint.h> header file. */
+/* Define if you have the <stdint.h> header file. */
 #undef HAVE_STDINT_H
 
-/* Define to 1 if you have the <stdlib.h> header file. */
+/* Define if you have the <stdlib.h> header file. */
 #undef HAVE_STDLIB_H
 
-/* Define to 1 if you have the `strerror' function. */
+/* Define if you have the `strerror' function. */
 #undef HAVE_STRERROR
 
-/* Define to 1 if you have the `strftime' function. */
+/* Define if you have the `strftime' function. */
 #undef HAVE_STRFTIME
 
-/* Define to 1 if you have the <strings.h> header file. */
+/* Define if you have the <strings.h> header file. */
 #undef HAVE_STRINGS_H
 
-/* Define to 1 if you have the <string.h> header file. */
+/* Define if you have the <string.h> header file. */
 #undef HAVE_STRING_H
 
-/* Define to 1 if you have the `strlcat' function. */
+/* Define if you have the `strlcat' function. */
 #undef HAVE_STRLCAT
 
-/* Define to 1 if you have the `strlcpy' function. */
+/* Define if you have the `strlcpy' function. */
 #undef HAVE_STRLCPY
 
-/* Define to 1 if you have the `strmode' function. */
+/* Define if you have the `strmode' function. */
 #undef HAVE_STRMODE
 
-/* Define to 1 if you have the `strsep' function. */
+/* Define if you have the `strsep' function. */
 #undef HAVE_STRSEP
 
-/* Define to 1 if `st_blksize' is member of `struct stat'. */
+/* Define if `st_blksize' is member of `struct stat'. */
 #undef HAVE_STRUCT_STAT_ST_BLKSIZE
 
-/* Define to 1 if you have the `sysconf' function. */
+/* Define if you have the `sysconf' function. */
 #undef HAVE_SYSCONF
 
-/* Define to 1 if you have the <sys/bitypes.h> header file. */
+/* Define if you have the <sys/bitypes.h> header file. */
 #undef HAVE_SYS_BITYPES_H
 
-/* Define to 1 if you have the <sys/bsdtty.h> header file. */
+/* Define if you have the <sys/bsdtty.h> header file. */
 #undef HAVE_SYS_BSDTTY_H
 
-/* Define to 1 if you have the <sys/cdefs.h> header file. */
+/* Define if you have the <sys/cdefs.h> header file. */
 #undef HAVE_SYS_CDEFS_H
 
-/* Define to 1 if you have the <sys/mman.h> header file. */
+/* Define if you have the <sys/mman.h> header file. */
 #undef HAVE_SYS_MMAN_H
 
-/* Define to 1 if you have the <sys/select.h> header file. */
+/* Define if you have the <sys/select.h> header file. */
 #undef HAVE_SYS_SELECT_H
 
-/* Define to 1 if you have the <sys/stat.h> header file. */
+/* Define if you have the <sys/stat.h> header file. */
 #undef HAVE_SYS_STAT_H
 
-/* Define to 1 if you have the <sys/stropts.h> header file. */
+/* Define if you have the <sys/stropts.h> header file. */
 #undef HAVE_SYS_STROPTS_H
 
-/* Define to 1 if you have the <sys/sysmacros.h> header file. */
+/* Define if you have the <sys/sysmacros.h> header file. */
 #undef HAVE_SYS_SYSMACROS_H
 
-/* Define to 1 if you have the <sys/time.h> header file. */
+/* Define if you have the <sys/time.h> header file. */
 #undef HAVE_SYS_TIME_H
 
-/* Define to 1 if you have the <sys/types.h> header file. */
+/* Define if you have the <sys/types.h> header file. */
 #undef HAVE_SYS_TYPES_H
 
-/* Define to 1 if you have the <sys/un.h> header file. */
+/* Define if you have the <sys/un.h> header file. */
 #undef HAVE_SYS_UN_H
 
-/* Define to 1 if you have the `tcgetpgrp' function. */
+/* Define if you have the `tcgetpgrp' function. */
 #undef HAVE_TCGETPGRP
 
-/* Define to 1 if you have the `time' function. */
+/* Define if you have the `time' function. */
 #undef HAVE_TIME
 
-/* Define to 1 if you have the <time.h> header file. */
+/* Define if you have the <time.h> header file. */
 #undef HAVE_TIME_H
 
-/* Define to 1 if you have the `truncate' function. */
+/* Define if you have the `truncate' function. */
 #undef HAVE_TRUNCATE
 
-/* Define to 1 if you have the <ttyent.h> header file. */
+/* Define if you have the <ttyent.h> header file. */
 #undef HAVE_TTYENT_H
 
-/* Define to 1 if you have the <unistd.h> header file. */
+/* Define if you have the <unistd.h> header file. */
 #undef HAVE_UNISTD_H
 
-/* Define to 1 if you have the `updwtmp' function. */
+/* Define if you have the `updwtmp' function. */
 #undef HAVE_UPDWTMP
 
-/* Define to 1 if you have the <usersec.h> header file. */
+/* Define if you have the <usersec.h> header file. */
 #undef HAVE_USERSEC_H
 
-/* Define to 1 if you have the <util.h> header file. */
+/* Define if you have the <util.h> header file. */
 #undef HAVE_UTIL_H
 
-/* Define to 1 if you have the `utimes' function. */
+/* Define if you have the `utimes' function. */
 #undef HAVE_UTIMES
 
-/* Define to 1 if you have the <utime.h> header file. */
+/* Define if you have the <utime.h> header file. */
 #undef HAVE_UTIME_H
 
-/* Define to 1 if you have the `utmpname' function. */
+/* Define if you have the `utmpname' function. */
 #undef HAVE_UTMPNAME
 
-/* Define to 1 if you have the `utmpxname' function. */
+/* Define if you have the `utmpxname' function. */
 #undef HAVE_UTMPXNAME
 
-/* Define to 1 if you have the <utmpx.h> header file. */
+/* Define if you have the <utmpx.h> header file. */
 #undef HAVE_UTMPX_H
 
-/* Define to 1 if you have the <utmp.h> header file. */
+/* Define if you have the <utmp.h> header file. */
 #undef HAVE_UTMP_H
 
-/* Define to 1 if you have the `vhangup' function. */
+/* Define if you have the `vhangup' function. */
 #undef HAVE_VHANGUP
 
-/* Define to 1 if you have the `vsnprintf' function. */
+/* Define if you have the `vsnprintf' function. */
 #undef HAVE_VSNPRINTF
 
-/* Define to 1 if you have the `waitpid' function. */
+/* Define if you have the `waitpid' function. */
 #undef HAVE_WAITPID
 
-/* Define to 1 if you have the `_getpty' function. */
+/* Define if you have the `_getpty' function. */
 #undef HAVE__GETPTY
 
-/* Define to 1 if you have the `__b64_ntop' function. */
+/* Define if you have the `__b64_ntop' function. */
 #undef HAVE___B64_NTOP
 
-/* Define to the address where bug reports for this package should be sent. */
-#undef PACKAGE_BUGREPORT
-
-/* Define to the full name of this package. */
-#undef PACKAGE_NAME
-
-/* Define to the full name and version of this package. */
-#undef PACKAGE_STRING
-
-/* Define to the one symbol short name of this package. */
-#undef PACKAGE_TARNAME
-
-/* Define to the version of this package. */
-#undef PACKAGE_VERSION
-
 /* The size of a `char', as computed by sizeof. */
 #undef SIZEOF_CHAR
 
@@ -860,11 +858,11 @@
 /* The size of a `short int', as computed by sizeof. */
 #undef SIZEOF_SHORT_INT
 
-/* Define to 1 if you have the ANSI C header files. */
+/* Define if you have the ANSI C header files. */
 #undef STDC_HEADERS
 
-/* Define to 1 if your processor stores words with the most significant byte
-   first (like Motorola and SPARC, unlike Intel and VAX). */
+/* Define if your processor stores words with the most significant byte first
+   (like Motorola and SPARC, unlike Intel and VAX). */
 #undef WORDS_BIGENDIAN
 
 /* Number of bits in a file offset, on hosts where this is settable. */
diff -Naur openssh-3.4p1/configure.ac openssh-3.4p1-gsi/configure.ac
--- openssh-3.4p1/configure.ac	Tue Jun 25 17:35:16 2002
+++ openssh-3.4p1-gsi/configure.ac	Tue Jul  2 08:29:53 2002
@@ -477,6 +477,107 @@
 	]
 )
 
+# Check whether the user wants GSI (Globus) support
+gsi_path="no"
+AC_ARG_WITH(gsi,
+	[  --with-gsi=PATH         Enable GSI/Globus authentication support],
+	[
+		gsi_path="$withval"
+	]
+)
+
+AC_ARG_WITH(globus,
+	[  --with-globus=PATH      Enable GSI/Globus authentication support],
+	[
+		gsi_path="$withval"
+	]
+)
+
+# Check whether the user has a Globus flavor type
+globus_flavor_type="no"
+AC_ARG_WITH(globus-flavor,
+	[  --with-globus-flavor=TYPE         Describe Globus flavor type (ex: gcc32dbg, etc.)],
+	[
+		globus_flavor_type="$withval"
+	]
+)
+
+if test "x$gsi_path" != "xno" ; then
+	# Globus GSSAPI configuration
+	AC_DEFINE(GSSAPI)
+	AC_DEFINE(GSI)
+
+	# Find GLOBUS/GSI installation Directory
+	AC_MSG_CHECKING(for Globus/GSI installation directory)
+
+	globus_install_dir=$gsi_path
+
+	if test "x$globus_install_dir" = "xyes" ; then
+                AC_MSG_ERROR(Cannot find Globus/GSI installation directory -- a path must be specified!)
+	fi
+	AC_MSG_RESULT($globus_install_dir)
+
+	# Find GLOBUS/GSI development directory
+	AC_MSG_CHECKING(for Globus/GSI development directory)
+
+	if test -d ${globus_install_dir}/lib ; then
+		# Looks like a flat directory structure from configure/make
+		# and not globus-install or gsi-install
+		globus_dev_dir=$globus_install_dir
+
+	else
+		# Assume a true globus installation with architecture
+		# directories and run globus-development-path to find
+		# the development directory
+
+		# Set GLOBUS_INSTALL_PATH
+		GLOBUS_INSTALL_PATH=$globus_install_dir
+		export GLOBUS_INSTALL_PATH
+
+		dev_path_program=${globus_install_dir}/bin/globus-development-path
+
+		if test ! -x ${dev_path_program} ; then
+			AC_MSG_ERROR(Cannot find Globus/GSI installation directory: program ${dev_path_program} does not exist or is not executable)
+		fi
+
+		globus_dev_dir=`${dev_path_program}`
+
+		if test -z "$globus_dev_dir" -o "X$globus_dev_dir" = "X<not found>" ; then
+			AC_MSG_ERROR(Cannot find Globus/GSI development directory)
+		fi
+
+		if test ! -d "$globus_dev_dir" ; then
+			AC_MSG_ERROR(Cannot find Globus/GSI development directory: $globus_dev_dir does not exist)
+		fi
+	fi
+	AC_MSG_RESULT($globus_dev_dir)
+
+	# Find GLOBUS/GSI flavor Directory
+	AC_MSG_CHECKING(for Globus flavor type)
+
+        if test "x$globus_flavor_type" = "xno" ; then
+		GSI_LIBS="-lglobus_gss_assist -lglobus_gss -lglobus_gaa"
+		GSI_LDFLAGS="-L${globus_dev_dir}/lib"
+		GSI_CFLAGS="-I${globus_dev_dir}/include"
+		AC_MSG_RESULT(none)
+	else
+                GLOBUS_FLAVOR_TYPE_INCL_DIR="${globus_dev_dir}/include/${globus_flavor_type}"
+
+		if test ! -d "$GLOBUS_FLAVOR_TYPE_INCL_DIR" ; then
+			AC_MSG_ERROR(Cannot find Globus flavor-specific include directory: ${GLOBUS_FLAVOR_TYPE_INCL_DIR})
+                fi
+
+		AC_MSG_RESULT($globus_flavor_type)
+		GSI_LIBS="${gsi_path}/lib/libglobus_gss_assist_${globus_flavor_type}.a ${gsi_path}/lib/libglobus_gssapi_gsi_${globus_flavor_type}.a"
+		GSI_CFLAGS="-I${GLOBUS_FLAVOR_TYPE_INCL_DIR}"
+	fi
+
+	LIBS="$LIBS $GSI_LIBS"
+	LDFLAGS="$LDFLAGS $GSI_LDFLAGS"
+	CFLAGS="$CFLAGS $GSI_CFLAGS"
+# End Globus/GSI section
+fi
+
 # Check whether user wants S/Key support
 SKEY_MSG="no" 
 AC_ARG_WITH(skey,
@@ -689,6 +790,7 @@
 			AC_CHECK_LIB(dl, dlopen, , )
 			AC_CHECK_LIB(pam, pam_set_item, , AC_MSG_ERROR([*** libpam missing]))
 			AC_CHECK_FUNCS(pam_getenvlist)
+			AC_CHECK_FUNCS(pam_putenv)
 
 			disable_shadow=yes
 			PAM_MSG="yes"
@@ -751,7 +853,20 @@
 		fi
 	]
 )
-LIBS="$LIBS -lcrypto"
+
+# Patch up SSL libraries for GSI authentication as needed
+if test "x$globus_flavor_type" != "xno" ; then
+	# For Globus 2, always link with the static libraries
+	LIBS="$LIBS ${gsi_path}/lib/libglobus_ssl_utils_${globus_flavor_type}.a ${gsi_path}/lib/libssl_${globus_flavor_type}.a ${gsi_path}/lib/libcrypto_${globus_flavor_type}.a"
+else
+	if test "x$gsi_path" != "xno" ; then
+		# Older GSI needs -lssl too
+		LIBS="$LIBS -lssl -lcrypto"
+	else # if no GSI authentication (i.e., OpenSSL default)
+		LIBS="$LIBS -lcrypto"
+	fi
+fi # globus_flavor_type
+
 AC_TRY_LINK_FUNC(RAND_add, AC_DEFINE(HAVE_OPENSSL),
 	[
 		dnl Check default openssl install dir
@@ -1728,6 +1843,31 @@
                                 blibpath="$blibpath:${KRB5ROOT}/lib"
                         fi
                         AC_CHECK_LIB(resolv, dn_expand, , )
+
+			AC_CHECK_LIB(gssapi,gss_init_sec_context,
+				[ AC_DEFINE(GSSAPI)
+				  K5LIBS="-lgssapi $K5LIBS" ],
+				[ AC_CHECK_LIB(gssapi_krb5,gss_init_sec_context,
+					[ AC_DEFINE(GSSAPI)
+				  	  K5LIBS="-lgssapi_krb5 $K5LIBS" ],
+					AC_MSG_WARN([Cannot find any suitable gss-api library - build may fail]),
+					$K5LIBS)
+				],
+				$K5LIBS)
+			
+			AC_CHECK_HEADER(gssapi.h, ,
+				[ unset ac_cv_header_gssapi_h
+				  CPPFLAGS="$CPPFLAGS -I${KRB5ROOT}/include/gssapi" 
+				  AC_CHECK_HEADERS(gssapi.h, ,
+					AC_MSG_WARN([Cannot find any suitable gss-api header - build may fail])
+				  ) 
+				]
+			)
+
+			oldCPP="$CPPFLAGS"
+			CPPFLAGS="$CPPFLAGS -I${KRB5ROOT}/include/gssapi"
+			AC_CHECK_HEADER(gssapi_krb5.h, ,
+					[ CPPFLAGS="$oldCPP" ])
 
                         KRB5=yes
                 fi
